# makefile: (C) TOYODA Eizi, 1994 for NECK project
# --- for MS-DOS
BJ=BJ
EXE=.EXE

TARGET=neck$(EXE)
INSTDIR=../../bin
CC=tcc
OBJS=main.o$(BJ) neck.o$(BJ) msb.o$(BJ) io.o$(BJ) kanzi.o$(BJ)\
 ansi.o$(BJ) nisui.o$(BJ) escr.o$(BJ) plot.o$(BJ)
SRCS=main.c neck.c msb.c io.c kanzi.c ansi.c nisui.c escr.c plot.c
SRCS_B=mknisui.c mknisui.dat
CFLAGS=-O # -DO_SJIS=1
LFLAGS=-lm
HDRS=neck.h

# --- for UNIX
# O_TARGET= -o $(TARGET)
# --- for MS-DOS
O_TARGET= -e$(TARGET)

all: target util

target:	$(TARGET)

$(TARGET): $(OBJS)
	$(CC) $(O_TARGET) $(OBJS) $(LFLAGS)

$(OBJS): $(HDRS)

.c.o$(BJ):
	$(CC) $(CFLAGS) -c $<

cls clear clean:
	rm -f $(OBJS) mknisui.o$(BJ) mknisui$(EXE)

install:
	cp $(TARGET) $(INSTDIR)

util: mknisui$(EXE)

mknisui$(EXE): mknisui.c
	$(CC) $(CFLAGS) mknisui.c

nisui.c: mknisui$(EXE) mknisui.dat
	mknisui mknisui.dat nisui.c

lint:
	lint $(LINTFLAGS) $(SRCS) $(LFLAGS)

ci:
	ci $(SRCS) $(HDRS) $(SRCS_B)

co:
	co -l $(SRCS) $(HDRS) $(SRCS_B)

arc:
	lha ute ../KFNEC.LZH $(SRCS) $(HDRS) $(SRCS_B) unix.mk dos.mk
