/* kanzi.c: (C) TOYODA Eizi 1994
 * for NECK Project
 * substitute a 2byte character PC-9801 cannot display.
 */

#include <stdio.h>
#include "neck.h"

#define		GETA	(0x222E)

/* Kigou83():
 * PC98-visible converting of
 * newly added KIGOU chrs. in JIS83
 * wc --> wc conversion
 */
	static wc_t
Kigou83(wc)
	wc_t	wc;
{
	static wc_t NecVis[] = {
		/* 0x2238 ... */
		GETA,   GETA,   0x2757, 0x276F,
		0x2165, 0x2166, 0x2D68, 0x2D69,
		/* 0x2240 ... */
		0x2D7C, 0x2D7B, GETA,   GETA,
		GETA,   GETA,   GETA,   GETA,
		GETA,   GETA,   0x2D65, 0x2D67,
		0x2C35, 0x2155, 0x2C2C, 0x2739,
		/* 0x2250 ... */
		0x273A, GETA,   GETA,   GETA,
		GETA,   GETA,   GETA,   GETA,
		GETA,   GETA,   GETA,   GETA,
		0x2D77, 0x2D76, 0x2D7B, 0x2752,
		/* 0x2260 ... */
		0x2226, 0x2D71, 0x2D70, 0x2154,
		0x2155, 0x2D75, 0x2167, 0x2167,
		0x2D7A, 0x2D72, 0x2D73, GETA,  
		GETA,   GETA,   GETA,   GETA,
		/* 0x2270 ... */
		GETA,   GETA,   0x2721, 0x2D4D,
		0x2174, 0x273E, 0x2D73, 0x2228,
		0x2728, 0x2741, GETA,   GETA,  
		GETA,   GETA,   0x217B
	};
	if (wc < 0x227F)
		return NecVis[wc - 0x2238];
	else
		return wc;
}

/* Keisen83():
 * JIS83 keisen sohen --> PC98 original keisen characters
 */
	static wc_t
Keisen83(wc)
	wc_t	wc;
{
	int		lo;
	static char s[33] = "$&04<8@PHX`%'37?;GWO_oDTL[cATI\\f";
	lo = wc - 0x2821;
	if (0 <= lo && lo < 32)
		return (0x2C00 | s[lo]);
	else
		return wc;
}

	static wc_t *
Nisui(wc)
	wc_t	wc;
{
	wc_t	*ws;
	if ((ws = nisuient(wc)) == NULL) {
		static wc_t ascii[3];
		ascii[0] = wc >> 8;
		ascii[1] = wc & 0x7F;
		ascii[2] = 0;
		return ascii;
	}
	return ws;
}

#define ISNEWKIGOU(wc) (0x2237 < (wc) && (wc) < 0x227F)

/* ksub():
 * invisible kanzi convertion entry point.
 */
	wc_t *
ksub(wc)
	wc_t	wc;
{
	static wc_t		ans[2];
	ans[0] = wc, ans[1] = 0;
	if ((wc >> 8) == 0x28)
		ans[0] = Keisen83(wc);
	if (ISNEWKIGOU(wc))
		ans[0] = Kigou83(wc);
	if (!flags.ni && 0x5020 < wc)
		return Nisui(wc);
	return ans;
}
