/* main.c: (C) TOYODA Eizi 1994
 * NECK Project
 * commandline option interpreter
 */

#include <stdio.h>
/* for malloc */
#if defined(__MSDOS__) 
#  include <stdlib.h>		/* for DOS TC++ */
#else 
#  include <malloc.h>		/* for SunOS 4.1.3 */
#endif
#include <string.h>
#include "neck.h"

flag_t		flags;
static boolean OptEnd = MYFALSE;

	static void
DispHelp()
{
	eputs("neck 0.2 (C)TOYODA Eizi 1994 - NEC Kanzi Convertor\
 for N88-BASIC TERMINAL MODE\n");
	eputs("usage: neck [options] [--] files...\n");
	eputs("\t-e\tinitially assume Euc(default)\n");
	eputs("\t-s\tinitially assume Sjis\n");
	eputs("\t-n\tturn to roman at Newline\n");
	eputs("\t-a\tforce ASCII in roman characters\n");
	eputs("\t-9\tforce 98-natural roman fonts\n");
	eputs("\t-c\ttake CSI as ^[[, not SJIS\n");
	eputs("\t-k\thate 1byte KATAKANA -- EUCize as possible\n");
	eputs("\t-7\tserial line is 7bit -- use SI/SO\n");
	eputs("\t-2\thave dai2-suizyun characters -- U2 or later\n");
	eputs("\t-v\thave backquote and backslash -- Vm21 or later\n");
	eputs("\t-D\tDebug mode --- make a file 'neck.log'\n");
	quit(0);
}

	void
initflag()
{
	flags.n = MYFALSE;
	flags.sj = SJIS_DEFAULT;
	flags.a = MYFALSE;
	flags.ank = MYFALSE;
	flags.ni = MYFALSE;
	flags.c = MYFALSE;
	flags.k = MYFALSE;
	flags.D = MYFALSE;
	flags.v = MYFALSE;
	flags.oseven = MYFALSE;
}

	int
optchar(c, set)
	char		c;
	boolean		set;
{
	if (c == NUL) {
		return NUL;
	} else if (c == 'h') {
		DispHelp();
	} else if (c == 'n') {
		flags.n = set;
	} else if (c == 's') {
		flags.sj = set;
	} else if (c == 'e') {
		flags.sj = (boolean)(!set);
	} else if (c == 'v') {
		flags.v = set;
	} else if (c == 'a') {
		flags.a = set;
	} else if (c == '9') {
		flags.ank = set;
	} else if (c == 'c') {
		flags.c = set;
	} else if (c == 'k') {
		flags.k = set;
	} else if (c == '2') {
		flags.ni = set;
	} else if (c == 'D') {
		flags.D = set;
	} else if (c == '7') {
		flags.oseven = set;
	} else {
		myputc(c);
		eputs(": unknown option flag\n");
		return NUL;
	};
	return c;
}

	static void
OptPret(opts)
	char *opts;
{
	if (streq(opts, "--")) {
		OptEnd = MYTRUE;
		return;
	} else {
		int		i;
		for (i=1; optchar(opts[i], MYTRUE); i++)
			;	/* VOID */
	}
}

	static boolean
IsOpt(s)
	char	*s;
{
	if (s[0] != '-')
		return MYFALSE;
	if (s[1] == '\0')
		return MYFALSE;
	if (OptEnd)
		return MYFALSE;
	return MYTRUE;
}

	static int *
ArgPret(argc, argv)
	int		argc;
	char	*argv[];
{
	int		i;
	int		fc=0, *findx;
	/* NOSTRICT */
	findx = (int *)malloc((unsigned)((argc+1) * sizeof(int)));
	for (i=1; i<argc; i++) {
		if (IsOpt(argv[i])) {
			OptPret(argv[i]);
		} else {
			/* take as input filename */
			findx[fc] = i;
			fc++;
		}
	}
	findx[fc] = NULL;
	return findx;
}

	int
main(argc, argv)
	int		argc;
	char	*argv[];
{
	int		*findx;
	initflag();
	findx = ArgPret(argc, argv);
	openl();
	if (findx[0] == NULL) {
		fileloop("-");
	} else {
		while(*findx != NULL) {
			fileloop(argv[*findx]);
			findx++;
		}
	}
	/* NOSTRICT */
	(void)free((char *)findx);
	closel();
	return 0;
}

	void
quit(retcode)
	int	retcode;
{
	extern void exit();
	closel();
	exit(retcode);
}
