/* mknisui.c: (C) TOYODA Eizi 1994
 * for NECK Project
 * dai2 suijun convertor generator
 */

#include <stdio.h>
#include <ctype.h>
#include "neck.h"		/* for boolean type */

#define	ENTRYLEN	4
#define	TABLEN		256

	static void
BeginOutput(output)
	FILE	*output;
{
	(void)fputs("/* generated C source: (C) TOYODA Eizi 1994\n", output);
	(void)fputs(" * for NECK Project\n", output);
	(void)fputs(" * dai2 suijun convertor generator\n", output);
	(void)fputs(" */\n\n", output);
	(void)fputs("#include <stdio.h>\n", output);
	(void)fputs("#include \"neck.h\"\n\n", output);

	(void)fputs("\twc_t *\n", output);
	(void)fputs("nisuient(wc)\n\twc_t\twc;\n", output);
	(void)fputs("{\n", output);
	(void)fputs("\tstatic wc_t\tans[3];\n", output);
}

	static void
PrintEntry(arv,output)
	wc_t	*arv;
	FILE	*output;
{
	static boolean	first = MYTRUE;
	if (first) {
		first = MYFALSE;
	} else {
		(void)fputs("\t} else", output);
	}
	(void)fprintf(output, "\tif (wc == 0x%04X) {\n", (int)arv[0]);
	(void)fprintf(output, "\t\tans[0] = 0x%04X;\n", (int)arv[1]);
	(void)fprintf(output, "\t\tans[1] = 0x%04X;\n", (int)arv[2]);
	(void)fprintf(output, "\t\tans[2] = 0x0000;\n");
	(void)fprintf(output, "\t\treturn ans;\n");
}

	static void
EndOutput(output)
	FILE	*output;
{
	(void)fputs("\t}\n", output);
	(void)fputs("\treturn NULL;\n", output);
	(void)fputs("}\n", output);
}

/* text --> entry compilation */

	static char
ChrHex(c)
	int		c;
{
	if ('0' <= c && c <= '9')
		return (c - '0');
	if ('A' <= c && c <= 'F')
		return (c - 'A' + 0x0A);
	if ('a' <= c && c <= 'f')
		return (c - 'a' + 0x0a);
	return 0;
}

	static char *
HexaPret(s, ansp)
	char	*s;
	wc_t	*ansp;
{
	while (isxdigit(*s)) {
		(*ansp) <<= 4;
		*ansp |= ChrHex(*s) & 0x0F;
		s++;
	}
	return (s-1);
}

	static char *
BkslshPret(s, ansp)
	char	*s;
	wc_t	*ansp;
{
	s++;
	while (isgraph(*s & 0x7F)) {
		(*ansp) <<= 8;
		*ansp |= *s & 0x7F;
		s++;
	}
	return (s-1);
}

/* LinePret():
 * nisui-datafile interpretation
 */
	static void
LinePret(buf, output)
	char	buf[];
	FILE	*output;
{
	char	*s;
	int		arc;			/* arg. counter */
	wc_t	arv[ENTRYLEN];	/* arg. vector */
	wc_t	acc;			/* accumlator */
	boolean	waitsp; 		/* acc has a value */
	acc = 0, arc = 0, waitsp = MYFALSE;
	for (s = buf; *s; s++) {
		if (*s == '#') {
			break;
		} else if (*s == ' ' || *s == '\t' || *s == '\n') {
			if (waitsp) {
				arv[arc] = acc;
				acc = 0;
				if (++arc >= ENTRYLEN-1) break;
				waitsp = MYFALSE;
			}
		} else if (*s == '\\') {
			s = BkslshPret(s, &acc);
			waitsp = MYTRUE;
		} else if (isxdigit(*s)) {
			s = HexaPret(s, &acc);
			waitsp = MYTRUE;
		}
	}
	arv[arc] = 0;
	if (arc >= 2)
		PrintEntry(arv, output);
}

	static void
FilePret(input, output)
	FILE	*input, *output;
{
	char	buf[256];
	BeginOutput(output);
	while (fgets(buf, sizeof(buf), input) != NULL) {
		LinePret(buf, output);
	}
	EndOutput(output);
}

	int
main(argc, argv)
	int		argc;
	char	*argv[];
{
	FILE	*input, *output;
	if (argc < 2)
		input = stdin;
	else
		input = fopen(argv[1], "rt");
	if (argc < 3)
		output = stdout;
	else
		output = fopen(argv[2], "wt");
	FilePret(input, output);
	(void)fclose(input);
	(void)fclose(output);
	return 0;
}
